#ifndef TLSCALLBACK
#define TLSCALLBACK

#include <windows.h>
#include <stdio.h>
#include <string>

#define SIZE_TLS_DIRECTORY 6 * sizeof(DWORD)
#define OFFSET_THIS_IS 0x4
#define DEBUG

/*
TLSCallBack par 0vercl0k.

Il semblerait que sur certains binaire compil avec gcc, la table se voit crite dans un endroit reserv par le compilateur.
Celui-ci se servirait de cette espce de table pour stocker des routines de destructeurs par exemple, enfin bref cette classe est
loin d'tre un chef d'oeuvre..elle est juste on dira fonctionnel :).
Elle m'aura servit "d'exercice" au coding en cpp.
*/

class TlsCallBack
{
    private:

    /* Attribut */

    long addressOfCallBackRoutine , offsetOfFirstSectionR , offsetOfFirstSectionV , offsetOfDirectory , offsetOfCallBack , offsetOfDwordNull , offsetOfCallBackTable , offsetOfEnd , imgBase;
    char *ptr , *tmp;
    HANDLE fMapped;
    PIMAGE_NT_HEADERS pNtHead;

    /*          */

    int translateAddrToFileOffset(long _addr);
    int scanExecutable(int _size , long* var);
    int addToPeHeaderTlsDirectory();
    int mapFileInMemory(std::string name);

    public:
    TlsCallBack(std::string fName);
    TlsCallBack(std::string fName , long _addr);
    ~TlsCallBack();

    void setAddressOfRoutine(long _addr);
    int putTlsDirectory();

};

/* Constructeur et destructeur */

TlsCallBack::TlsCallBack(std::string fName)
{
    addressOfCallBackRoutine = 0;
    offsetOfDirectory = 0;
    offsetOfCallBack  = -1;
    offsetOfCallBackTable = 0;
    offsetOfDwordNull = 0;
    offsetOfEnd = 0;
    offsetOfFirstSectionR = 0;
    offsetOfFirstSectionV = 0;
    pNtHead = NULL;
    fMapped  = NULL;

    if(!this->mapFileInMemory(fName))
    {
        printf("[!] Erreur lors du mapping du fichier en mmoire.\n");
        return;
    }

    if( (offsetOfCallBack = this->translateAddrToFileOffset(addressOfCallBackRoutine)) == -1)
        return;

    return;
}

TlsCallBack::TlsCallBack(std::string fName , long _addr)
{
    addressOfCallBackRoutine = _addr;
    offsetOfDirectory = 0;
    offsetOfCallBack  = -1;
    offsetOfCallBackTable = 0;
    offsetOfDwordNull = 0;
    offsetOfEnd = 0;
    offsetOfFirstSectionR = 0;
    offsetOfFirstSectionV = 0;
    pNtHead = NULL;
    fMapped  = NULL;

    if(!this->mapFileInMemory(fName))
    {
        printf("[!] Erreur lors du mapping du fichier en mmoire.\n");
        return;
    }

    if( (offsetOfCallBack = this->translateAddrToFileOffset(addressOfCallBackRoutine)) == -1)
        return;
}


TlsCallBack::~TlsCallBack()
{
    if(fMapped != INVALID_HANDLE_VALUE && fMapped != 0)
        UnmapViewOfFile(fMapped);
    return;
}

/*                             */


int TlsCallBack::mapFileInMemory(std::string name)
{
    HANDLE bin , binMapping;
    PIMAGE_DOS_HEADER pImgDos;

    if( (bin = CreateFile(name.c_str() , GENERIC_READ|GENERIC_WRITE , FILE_SHARE_READ|FILE_SHARE_WRITE , NULL , OPEN_EXISTING , 0 , 0)) == INVALID_HANDLE_VALUE)
        return 0;

    if( (binMapping = CreateFileMapping(bin , NULL , PAGE_READWRITE , 0 , 0 , NULL)) == INVALID_HANDLE_VALUE)
        return 0;

    if( (fMapped = MapViewOfFile(binMapping , FILE_MAP_ALL_ACCESS , 0 , 0 , 0)) == INVALID_HANDLE_VALUE)
        return 0;

    pImgDos = (PIMAGE_DOS_HEADER)fMapped;
    pNtHead = (PIMAGE_NT_HEADERS)((PUCHAR)pImgDos+pImgDos->e_lfanew);

    offsetOfFirstSectionR = *(long *)((PUCHAR)pNtHead + sizeof(IMAGE_NT_HEADERS) + 0x14);
    offsetOfFirstSectionV = *(long *)((PUCHAR)pNtHead + sizeof(IMAGE_NT_HEADERS) + 0x0c);
    offsetOfEnd = offsetOfFirstSectionR + *(long *)((PUCHAR)pNtHead + sizeof(IMAGE_NT_HEADERS) + 0x10);

    ptr = (char*)pImgDos + offsetOfFirstSectionR;
    tmp = ptr;
    return 1;
}

void TlsCallBack::setAddressOfRoutine(long _addr)
{
    addressOfCallBackRoutine = _addr;
    return;
}

int TlsCallBack::translateAddrToFileOffset(long _addr)
{
    if(fMapped == NULL)
        return -1;

    imgBase = pNtHead->OptionalHeader.ImageBase;

    if(_addr < imgBase)
        return -1;

    return _addr-imgBase;
}

int TlsCallBack::scanExecutable(int _size , long* var)
{
    int result , j = 0 , i = 0;

    while(tmp < (char*)(offsetOfEnd+(int)fMapped))
    {
        if(tmp[i] == 0)
            j++;
        else
            j = 0;

        result = (i-j);
        if(_size == j)
        {
            *var = (tmp - ptr)+result+1;
            tmp += i+1;
            return 1;
        }
        i++;
    }
    return 0;
}

int TlsCallBack::addToPeHeaderTlsDirectory()
{
    PIMAGE_SECTION_HEADER pImgSect = NULL;
    if(offsetOfDirectory == 0)
        return 0;

    pNtHead->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_TLS].VirtualAddress = offsetOfDirectory+offsetOfFirstSectionV;
    pNtHead->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_TLS].Size = SIZE_TLS_DIRECTORY;
    pImgSect = (PIMAGE_SECTION_HEADER)((char*)pNtHead + sizeof(IMAGE_NT_HEADERS));
    pImgSect->Characteristics |= IMAGE_SCN_MEM_WRITE;

    return 1;
}

int TlsCallBack::putTlsDirectory()
{
    if(addressOfCallBackRoutine == 0)
        return 0;

    if(this->scanExecutable(sizeof(DWORD),&offsetOfDwordNull ) == 0)
        return 0;

    if(this->scanExecutable(sizeof(DWORD)*2,&offsetOfCallBackTable) == 0)
        return 0;

    if(this->scanExecutable(SIZE_TLS_DIRECTORY,&offsetOfDirectory) == 0)
        return 0;

#ifdef DEBUG
    printf("OffsetOfDwordNull : 0x%x , OffsetOfCallBackTable : 0x%x , OffsetOfDirectory : 0x%x.\n" , (int)(imgBase+offsetOfFirstSectionV+offsetOfDwordNull) , (int)(imgBase+offsetOfFirstSectionV+offsetOfCallBackTable) , (int)(imgBase+offsetOfFirstSectionV+offsetOfDirectory));
#endif

    *(PDWORD)(ptr+offsetOfDirectory)     = imgBase+offsetOfFirstSectionV+offsetOfDirectory;
    *(PDWORD)(ptr+offsetOfDirectory+4)   = imgBase+offsetOfFirstSectionV+offsetOfDirectory;
    *(PDWORD)(ptr+offsetOfDirectory+8)   = imgBase+offsetOfFirstSectionV+offsetOfDwordNull;
    *(PDWORD)(ptr+offsetOfDirectory+12)  = imgBase+offsetOfFirstSectionV+offsetOfCallBackTable;
    *(PDWORD)(ptr+offsetOfDirectory+16)  = 0;
    *(PDWORD)(ptr+offsetOfDirectory+20)  = 0;

    *(PDWORD)(ptr+offsetOfCallBackTable) = addressOfCallBackRoutine;

    if(this->addToPeHeaderTlsDirectory() == 0)
        return 0;

#ifdef DEBUG
    printf("TLS Callback Table : %x.\n" , (int)(imgBase+offsetOfFirstSectionV+offsetOfDirectory));
#endif

    return 1;
}

#endif
